From c178b3e690b989153cbc0572c0c78b30eba211dd Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:54:10 +0000
Subject: [PATCH 705/1001] Create a widget registry class


---

diff --git a/hubs/app.py b/hubs/app.py
old mode 100755
new mode 100644
index 60981cf..0e81a8d
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -104,5 +104,12 @@ def check_auth():
     else:
         flask.g.auth = munch.Munch(logged_in=False)
 
+# Register widgets
+import hubs.widgets
+hubs.widgets.registry.register_list(app.config["WIDGETS"])
 
+# Register routes
 import hubs.views
+
+# Add widget-specific routes
+hubs.widgets.registry.register_routes(app)
diff --git a/hubs/default_config.py b/hubs/default_config.py
old mode 100755
new mode 100644
index e540ad9..be038ad
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -32,3 +32,29 @@ OIDC_SCOPES = [
 # TODO - instead of 'develop', use the version from pkg_resources to figure out
 #        the right tag to link people to.  AGPL ftw.
 SOURCE_URL = 'https://pagure.io/fedora-hubs/blob/develop/f'  # /hubs/widgets/badges.py'
+
+
+WIDGETS = [
+    'hubs.widgets.dummy.Dummy',
+    'hubs.widgets.stats.Stats',
+    'hubs.widgets.rules.Rules',
+    'hubs.widgets.sticky.Sticky',
+    'hubs.widgets.about.About',
+    'hubs.widgets.badges.Badges',
+    'hubs.widgets.library.Library',
+    'hubs.widgets.linechart.Linechart',
+    'hubs.widgets.fedmsgstats.FedmsgStats',
+    'hubs.widgets.feed.Feed',
+    'hubs.widgets.subscriptions.Subscriptions',
+    'hubs.widgets.meetings.Meetings',
+    'hubs.widgets.pagure_pr.PagurePRs',
+    'hubs.widgets.github_pr.GitHubPRs',
+    'hubs.widgets.pagureissues.PagureIssues',
+    'hubs.widgets.githubissues.GitHubIssues',
+    'hubs.widgets.bugzilla.Bugzilla',
+    'hubs.widgets.fhosted.FedoraHosted',
+    'hubs.widgets.memberships.Memberships',
+    'hubs.widgets.contact.Contact',
+    'hubs.widgets.workflow.pendingacls.PendingACLs',
+    'hubs.widgets.workflow.updates2stable.Updates2Stable',
+    ]
diff --git a/hubs/views/__init__.py b/hubs/views/__init__.py
index 54f6bd1..1c97db4 100644
--- a/hubs/views/__init__.py
+++ b/hubs/views/__init__.py
@@ -6,45 +6,3 @@ from .widget import *
 from .user import *
 from .api import *
 from .plus_plus import *
-
-#
-# Add widget-specific routes
-#
-
-import flask
-import functools
-import hubs.models
-import hubs.widgets
-from sqlalchemy.orm.exc import NoResultFound
-from hubs.app import app, session
-from .utils import get_widget
-
-def _widget_view_decorator(func):
-    """
-    This internal decorator will edit the view function arguments.
-
-    It will:
-    - remove the hub name and the widget primary key
-    - add the database session and the widget instance
-    """
-    @functools.wraps(func)
-    def inner(*args, **kwargs):
-        hubname = kwargs.pop("hub")
-        widgetidx = kwargs.pop("idx")
-        widget = get_widget(hubname, widgetidx)
-        return func(session, widget, *args, **kwargs)
-    return inner
-
-def _load_widget_views():
-    for name, module in hubs.widgets.registry.items():
-        for params in getattr(module, 'ROUTES', []):
-            params["rule"] = "/<hub>/<int:idx>/widget/" \
-                             + params["rule"].lstrip("/")
-            if not params.get("endpoint"):
-                params["endpoint"] = params["view_func_name"]
-            params["endpoint"] = "%s_%s" % (name, params["endpoint"])
-            params["view_func"] = _widget_view_decorator(
-                getattr(module, params.pop("view_func_name")))
-            app.add_url_rule(**params)
-
-_load_widget_views()
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
old mode 100755
new mode 100644
index 95253e7..6d5f257
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -1,132 +1,10 @@
+"""
+Attributes:
+    registry (dict): This dictionary is a registry of available widgets in
+        Fedora Hubs.
+"""
 from __future__ import unicode_literals
 
-from hubs.widgets import dummy
-from hubs.widgets import stats
-from hubs.widgets import rules
-from hubs.widgets import sticky
-from hubs.widgets import about
-from hubs.widgets import badges
-from hubs.widgets import library
-from hubs.widgets import linechart
-from hubs.widgets import fedmsgstats
-from hubs.widgets import feed
-from hubs.widgets import subscriptions
-from hubs.widgets import meetings
-from hubs.widgets import pagure_pr
-from hubs.widgets import github_pr
-from hubs.widgets import pagureissues
-from hubs.widgets import githubissues
-from hubs.widgets import bugzilla
-from hubs.widgets import fhosted
-from hubs.widgets import memberships
-from hubs.widgets import contact
+from .registry import WidgetRegistry
 
-from hubs.widgets.workflow import pendingacls
-from hubs.widgets.workflow import updates2stable
-
-from hubs.widgets.base import AGPLv3, smartcache
-
-registry = {
-    'dummy': dummy,
-    'stats': stats,
-    'rules': rules,
-    'sticky': sticky,
-    'about': about,
-    'badges': badges,
-    'library': library,
-    'linechart': linechart,
-    'fedmsgstats': fedmsgstats,
-    'feed': feed,
-    'subscriptions': subscriptions,
-    'meetings': meetings,
-    'pagure_pr': pagure_pr,
-    'github_pr': github_pr,
-    'pagureissues': pagureissues,
-    'githubissues': githubissues,
-    'bugzilla': bugzilla,
-    'fedorahosted': fhosted,
-    'memberships': memberships,
-    'contact': contact,
-
-    'workflow.pendingacls': pendingacls,
-    'workflow.updates2stable': updates2stable,
-}
-
-
-def validate_registry(registry):
-    """ Ensure that the widgets in the registry have the bits they need.
-
-    - Check that a template is available and has a render callable.
-    - Look for a data function, etc..
-    """
-    for name, module in registry.items():
-        if not hasattr(module, 'template'):
-            raise AttributeError('%r has no "template"' % module)
-        if not hasattr(module.template, 'render'):
-            raise AttributeError('%r\'s template has no "render"' % module)
-        if not callable(module.template.render):
-            raise TypeError('%r\'s template.render not callable' % module)
-
-        if not hasattr(module, 'position'):
-            raise AttributeError('%r has not "position" function' % module)
-        if module.position not in ['left', 'right', 'both']:
-            raise TypeError(
-                '%r\'s "position" is not: `left`, `right` or `both`'
-                % module)
-
-        if not hasattr(module, 'data'):
-            raise AttributeError('%r has not "data" function' % module)
-        if not callable(module.data):
-            raise TypeError('%r\'s "data" is not callable' % module)
-
-        if hasattr(module, 'chrome'):
-            if not callable(module.chrome):
-                raise TypeError('%r\'s "chrome" is not callable' % module)
-
-
-def prepare_registry(registry):
-    """ Do things ahead of time that we can to the registry.
-
-    - Wrap a cache layer around the data functions.
-    - Wrap any chrome around the render functions.
-    """
-    for name, module in registry.items():
-        # Wrap chrome around the render function
-        module.render = module.template.render
-        if hasattr(module, 'chrome'):
-            module.render = module.chrome(module.render)
-
-        # Put source links in all API results
-        module.data = AGPLv3(name)(module.data)
-
-        # Wrap the data functions in a cache layer to be invalidated by fedmsg
-        # TODO -- we could just do this with a decorator to be explicit..
-        module.data = smartcache(module.data)
-
-
-validate_registry(registry)
-prepare_registry(registry)
-
-
-def get_site_vars():
-    import flask
-    return dict(
-        session=flask.app.session,
-        g=flask.g,
-        url_for=flask.url_for,
-    )
-
-
-def render(module, session, widget, *args, **kwargs):
-    """ Main API entry point.
-
-    Call this to render a widget into HTML
-    """
-    # The API returns exactly this data.  Shared cache
-    data = module.data(session, widget, *args, **kwargs)
-
-    # Also expose some site-level info to the widget here at render-time
-    data.update(get_site_vars())
-
-    # Use the API data to fill out a template, and potentially decorate it.
-    return module.render(**data)
+registry = WidgetRegistry()
diff --git a/hubs/widgets/registry.py b/hubs/widgets/registry.py
new file mode 100644
index 0000000..006eced
--- /dev/null
+++ b/hubs/widgets/registry.py
@@ -0,0 +1,68 @@
+from __future__ import unicode_literals
+
+from importlib import import_module
+from six.moves import UserDict
+from hubs.widgets.base import Widget
+
+
+class WidgetRegistry(UserDict):
+    """
+    The widget registry.
+
+    It behaves like a dictionary where widget names are keys and widget class
+    instances are values.  There are additional methods to register widgets and
+    widget-specific routes.
+    """
+
+    def register_list(self, widget_list):
+        """
+        Register a list of widget class paths.
+
+        Args:
+            widget_list (list): List of Python paths to widget classes that
+                must be registered.
+        """
+        for widget_path in widget_list:
+            self.register(widget_path)
+
+    def register(self, widget_path):
+        """
+        Register a widget.
+
+        Args:
+            widget_path (str): Python path to the subclass of
+                `hubs.widgets.base.Widget`.
+        """
+        mod_path, _, cls_name = widget_path.rpartition('.')
+        mod = import_module(mod_path)
+        try:
+            widget_class = getattr(mod, cls_name)
+        except AttributeError:
+            raise ValueError("Can't find widget %s" % widget_path)
+        if not issubclass(widget_class, Widget):
+            raise ValueError(
+                "Widget %s must be a subclass of %s.Widget"
+                % (widget_path, Widget.__module__))
+        widget = widget_class()
+        if not widget.name:
+            prefix = 'hubs.widgets.'
+            if widget_path.startswith(prefix):
+                widget.name = widget_path[len(prefix):]
+            else:
+                widget.name = widget_path
+        widget.validate()
+        self.data[widget.name] = widget
+
+    def register_routes(self, app):
+        """
+        Register widget-specific routes with the provided app.
+
+        This is not done automatically to allow widgets to be registered
+        without instantiating the Flask application.
+
+        Args:
+            app (flask.Flask): The Flask application to register the views
+                with.
+        """
+        for widget in self.values():
+            widget.register_routes(app)
diff --git a/populate.py b/populate.py
index d4b262d..503b0e9 100755
--- a/populate.py
+++ b/populate.py
@@ -6,12 +6,24 @@ from __future__ import unicode_literals
 import json
 
 import hubs.models
+import hubs.widgets
 
 import fedmsg.config
 fedmsg_config = fedmsg.config.load_config()
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
 
+# Register widgets we will use
+hubs.widgets.registry.register_list([
+    "hubs.widgets.contact.Contact",
+    "hubs.widgets.stats.Stats",
+    "hubs.widgets.rules.Rules",
+    "hubs.widgets.meetings.Meetings",
+    "hubs.widgets.about.About",
+    "hubs.widgets.sticky.Sticky",
+    "hubs.widgets.dummy.Dummy",
+    ])
+
 users = ['mrichard', 'duffy', 'ryanlerch', 'gnokii', 'nask0',
          'abompard', 'decause', 'ralph', 'lmacken', 'croberts', 'mattdm',
          'pravins', 'keekri', 'linuxmodder', 'bee2502', 'jflory7']

